<?php
session_save_path('./wikidata/sessions');
session_cache_limiter('private,must-revalidate');
session_start();
while (($verification = rand() % 10000) < 1000);
$_SESSION['verification'] = $verification;
if (function_exists('imagepng')) {
	Header("Content-type:image/png");
} else
	if (function_exists('imagegif')) {
		Header("Content-type:image/gif");
	} else {
		function make_seed() {
			list ($usec, $sec) = explode(' ', microtime());
			return (float) $sec + ((float) $usec * 100000);
		}
		mt_srand(make_seed());

		function set_pixel($r, $g, $b, $x, $y) {
			global $sx, $sy, $pixels;
			$ofs = 3 * ($sx * $y + $x);
			$pixels[$ofs] = chr($r);
			$pixels[$ofs +1] = chr($g);
			$pixels[$ofs +2] = chr($b);
		}

		function set_4pixel($r, $g, $b, $x, $y) {
			global $sx, $sy, $pixels;

			$ofs = 3 * ($sx * $y + $x);
			$pixels[$ofs] = chr($r);
			$pixels[$ofs +1] = chr($g);
			$pixels[$ofs +2] = chr($b);
			$pixels[$ofs +3] = chr($r);
			$pixels[$ofs +4] = chr($g);
			$pixels[$ofs +5] = chr($b);
			$ofs += 3 * $sx;
			$pixels[$ofs] = chr($r);
			$pixels[$ofs +1] = chr($g);
			$pixels[$ofs +2] = chr($b);
			$pixels[$ofs +3] = chr($r);
			$pixels[$ofs +4] = chr($g);
			$pixels[$ofs +5] = chr($b);
		}
		function draw2digits($x, $y, $number) {
			draw_digit($x, $y, (int) ($number / 10));
			draw_digit($x +11, $y, $number % 10);
		}

		function draw_digit($x, $y, $digit) {
			global $sx, $sy, $pixels, $digits, $lines;

			$digit = $digits[$digit];
			$m = 8;
			for ($b = 1, $i = 0; $i < 7; $i++, $b *= 2) {
				if (($b & $digit) == $b) {
					$j = $i * 4;
					$x0 = $lines[$j] * $m + $x;
					$y0 = $lines[$j +1] * $m + $y;
					$x1 = $lines[$j +2] * $m + $x;
					$y1 = $lines[$j +3] * $m + $y;
					if ($x0 == $x1) {
						$ofs = 3 * ($sx * $y0 + $x0);
						for ($h = $y0; $h <= $y1; $h++, $ofs += 3 * $sx) {
							$pixels[$ofs] = chr(0);
							$pixels[$ofs +1] = chr(0);
							$pixels[$ofs +2] = chr(0);
						}
					} else {
						$ofs = 3 * ($sx * $y0 + $x0);
						for ($w = $x0; $w <= $x1; $w++) {
							$pixels[$ofs++] = chr(0);
							$pixels[$ofs++] = chr(0);
							$pixels[$ofs++] = chr(0);
						}
					}
				}
			}
		}

		function add_chunk($type) {
			global $result, $data, $chunk, $crc_table;

			$len = strlen($data);
			$chunk = pack("c*", ($len >> 24) & 255, ($len >> 16) & 255, ($len >> 8) & 255, $len & 255);
			$chunk .= $type;
			$chunk .= $data;

			// calculate a CRC checksum with the bytes chunk[4..len-1]
			$z = 16777215;
			$z |= 255 << 24;
			$c = $z;
			for ($n = 4; $n < strlen($chunk); $n++) {
				$c8 = ($c >> 8) & 0xffffff;
				$c = $crc_table[($c ^ ord($chunk[$n])) & 0xff] ^ $c8;
			}
			$crc = $c ^ $z;

			$chunk .= chr(($crc >> 24) & 255);
			$chunk .= chr(($crc >> 16) & 255);
			$chunk .= chr(($crc >> 8) & 255);
			$chunk .= chr($crc & 255);

			$result .= $chunk;
		}

		function add_num($num) {
			global $verification;
			$d = 4;
			$j = pow(10, $num -1);
			for ($i = 0; $i < $num; $i++) {
				$n = mt_rand(0, 9);
				$verification += $n * $j;
				draw_digit($d, 2, $n);
				$d += 11;
				$j = $j / 10;
			}
		}

		function add_radom_point($num) {
			global $sx, $sy;
			for ($i = 0; $i < $num; $i++) {
				$r = mt_rand(0, 255);
				$g = mt_rand(0, 255);
				$b = mt_rand(0, 255);
				$x = mt_rand(0, $sx);
				$y = mt_rand(0, $sy);
				set_pixel($r, $g, $b, $x, $y);
			}
		}

		$verification = 0;

		$sx = 50;
		$sy = 21;
		$pixels = "";


		for ($h = 0; $h < $sy; $h++) {
			for ($w = 0; $w < $sx; $w++) {
				$r = 100 / $sx * $w +155;
				$g = 100 / $sy * $h +155;
				$b = 255 - (100 / ($sx + $sy) * ($w + $h));
				$pixels .= chr($r);
				$pixels .= chr($g);
				$pixels .= chr($b);
			}
		}

		$digits = array (
			95,
			5,
			118,
			117,
			45,
			121,
			123,
			69,
			127,
			125
		);
		$lines = array (
			1,
			1,
			1,
			2,
			0,
			1,
			0,
			2,
			1,
			0,
			1,
			1,
			0,
			0,
			0,
			1,
			0,
			2,
			1,
			2,
			0,
			1,
			1,
			1,
			0,
			0,
			1,
			0
		);

		add_num(4);
		add_radom_point(32);

		$z = -306674912;
		for ($n = 0; $n < 256; $n++) {
			$c = $n;
			for ($k = 0; $k < 8; $k++) {
				$c2 = ($c >> 1) & 0x7fffffff;
				if ($c & 1)
					$c = $z ^ ($c2);
				else
					$c = $c2;
			}
			$crc_table[$n] = $c;
		}

		// PNG file signature
		$result = pack("c*", 137, 80, 78, 71, 13, 10, 26, 10);

		$data = pack("c*", ($sx >> 24) & 255, ($sx >> 16) & 255, ($sx >> 8) & 255, $sx & 255, ($sy >> 24) & 255, ($sy >> 16) & 255, ($sy >> 8) & 255, $sy & 255, 8, 2, 0, 0, 0);
		add_chunk("IHDR");

		$len = ($sx * 3 + 1) * $sy;
		$data = pack("c*", 0x78, 0x01, 1, $len & 255, ($len >> 8) & 255, 255 - ($len & 255), 255 - (($len >> 8) & 255));
		$start = strlen($data);
		$i2 = 0;
		for ($h = 0; $h < $sy; $h++) {
			$data .= chr(0);
			for ($w = 0; $w < $sx * 3; $w++) {
				$data .= $pixels[$i2++];
			}
		}

		// calculate a Adler32 checksum with the bytes data[start..len-1]
		$s1 = 1;
		$s2 = 0;
		for ($n = $start; $n < strlen($data); $n++) {
			$s1 = ($s1 +ord($data[$n])) % 65521;
			$s2 = ($s2 + $s1) % 65521;
		}
		$adler = ($s2 << 16) | $s1;

		$data .= chr(($adler >> 24) & 255);
		$data .= chr(($adler >> 16) & 255);
		$data .= chr(($adler >> 8) & 255);
		$data .= chr($adler & 255);
		add_chunk("IDAT");
		// IEND: marks the end of the PNG-file
		$data = "";
		add_chunk("IEND");
		$_SESSION['verification'] = $verification;
		echo ($result);
		exit ();
	}
$im = imagecreate(45, 20);
$black = ImageColorAllocate($im, 0, 0, 0);
$white = ImageColorAllocate($im, 255, 255, 255);
$gray = ImageColorAllocate($im, 200, 200, 200);
imagefill($im, 68, 30, $black);
imagestring($im, 5, 5, 3, $verification, $white);
for ($i = 0; $i < 200; $i++) {
	$randcolor = ImageColorallocate($im, rand(0, 255), rand(0, 255), rand(0, 255));
	imagesetpixel($im, rand() % 70, rand() % 30, $randcolor);
}
if (function_exists('imagepng')) {
	imagepng($im);
} else {
	imagegif($im);
}
ImageDestroy($im);
?>

