<?php
class DepartPage {
	var $numPerPage = 0;
	var $pageNow = 0;
	var $pageCount = 0;
	var $recordCount = 0;


	function DepartPage($numPerPage,$pageNow,$reCount) {
		if ($numPerPage <= 0) {
			$numPerPage = 10;
		}
		$this->numPerPage =$numPerPage;
		$this->setpageNow($pageNow);
		$this->setReCount($reCount);
	}

	function setReCount($reCount) {
		$this->recordCount = $reCount;
		if ($this->numPerPage > 0) {
			$this->pageCount = intval($reCount / $this->numPerPage);
			if ($reCount % $this->numPerPage > 0) {
				$this->pageCount += 1;
			}
		} else {
			if ($reCount == 0) {
				$this->pageCount = 0;
			} else {
				$this->pageCount = 1;
			}
		}
		if ($this->pageNow > $this->pageCount) {
			$this->pageNow = $this->pageCount;
		}
	}
	function setpageNow($i) {
		if ($i <= 0) {
			$i = 0;
		}
		$this->pageNow = $i;
	}


	function getBeginIndex() {
		$nBegin = 0;
		if ($this->numPerPage > 0 && $this->pageNow > 0) {
			$nBegin = $this->numPerPage * ($this->pageNow - 1);
		}
		return $nBegin;
	}


	function getEndIndex() {
		$nEnd = 0;
		if ($this->numPerPage > 0 && $this->pageNow > 0) {
			$nEnd = $this->numPerPage * $this->pageNow;
			if ($nEnd > $this->recordCount) {
				$nEnd = $this->recordCount;
			}
		}
		return $nEnd;
	}


	function reset() {
		$this->numPerPage = 0;
		$this->pageNow = 0;
		$this->pageCount = 0;
		$this->recordCount = 0;
	}


	function getpageCount() {
		return $this->pageCount;
	}


	function getReCount() {
		return $this->recordCount;
	}


	function getpageNow() {
		return $this->pageNow;
	}


	function getnumPerPage() {
		return $this->numPerPage;
	}


	function getFirstPage() {
		return $this->pageCount == 0 ? 0 : 1;
	}


	function getLastPage() {
		return $this->pageCount == 0 ? 0 : $this->pageCount;
	}


	function getNextPage() {
		$nextPage = 0;
		if ($this->pageCount > 0) {
			if ($this->pageNow < $this->pageCount) {
				$nextPage = $this->pageNow + 1;
			} else {
				$nextPage = $this->pageNow;
			}
		}
		return $nextPage;
	}


	function getPrePage() {
		$prePage = 0;
		if ($this->pageCount > 0) {
			if ($this->pageNow > 1) {
				$prePage = $this->pageNow - 1;
			} else {
				$prePage = $this->pageNow;
			}
		}
		return $prePage;
	}


	function getDepartStr($actionPath, $pageParaName = "n") {
		global $lang;
		$actionPath = $actionPath . "&amp;";
		$j = intval($this->numPerPage / 2);
		$strbuf = "";
		if ($this->pageNow > $this->pageCount && $this->pageCount != 0) {
			$this->pageNow = $this->pageCount - 1;
		}

		if ($this->pageNow <= 0) {
			$this->pageNow = 1;
		}

		if ($this->pageNow > 1) {
			$strbuf = $strbuf . "  ";
			$strbuf = $strbuf . "<a href=\"" . $actionPath . $pageParaName . "=" . $this->getFirstPage() . "\" >";
			$strbuf = $strbuf . $lang['commonFirstPage'];
			$strbuf = $strbuf . "</a>";
			$strbuf = $strbuf . "  ";
		}

		if ($this->pageNow > ($j +1)) {
			$strbuf = $strbuf . "  ";
			$strbuf = $strbuf . "<a href=\"" . $actionPath . $pageParaName . "=" . $this->getPrePage() . "\" >";
			$strbuf = $strbuf . $lang['commonPrevPage'];
			$strbuf = $strbuf . "</a>";
			$strbuf = $strbuf . "  ";
		}

		for ($i = ($this->pageNow - $j); $i < $this->pageNow; $i++) {
			if ($i <= 0)
				continue;
			$strbuf = $strbuf . "  ";
			$strbuf = $strbuf . "<a href=\"" . $actionPath . $pageParaName . "=" . $i . "\" >";
			$strbuf = $strbuf . "[" . $i . "]";
			$strbuf = $strbuf . "</a>";
			$strbuf = $strbuf . "  ";
		}
		$strbuf = $strbuf . "  ";

		if ($this->pageCount != 1 && $this->pageCount != 0) {
			$strbuf = $strbuf . "<span class=\"red\"> ";
			$strbuf = $strbuf . $this->pageNow;
			$strbuf = $strbuf . "</span>";
			$strbuf = $strbuf . "  ";
		}

		for ($i = ($this->pageNow + 1);($i < ($this->pageNow + $j)) && ($i <= $this->pageCount); $i++) {
			$strbuf = $strbuf . "  ";
			$strbuf = $strbuf . "<a href=\"" . $actionPath . $pageParaName . "=" . $i . "\" >";
			$strbuf = $strbuf . "[" . $i . "]";
			$strbuf = $strbuf . "</a>";
			$strbuf = $strbuf . "  ";
		}

		if ($this->pageNow + $j <= $this->pageCount) {
			$strbuf = $strbuf . "  ";
			$strbuf = $strbuf . "<a href=\"" . $actionPath . $pageParaName . "=" . $this->getNextPage() . "\" >";
			$strbuf = $strbuf . $lang['commonNextPage'];
			$strbuf = $strbuf . "</a>";
			$strbuf = $strbuf . "  ";
		}

		if ($this->pageNow < $this->pageCount) {
			$strbuf = $strbuf . "  ";
			$strbuf = $strbuf . "<a href=\"" . $actionPath . $pageParaName . "=" . $this->getLastPage() . "\" >";
			$strbuf = $strbuf . $lang['commonLastPage'];
			$strbuf = $strbuf . "</a>";
			$strbuf = $strbuf . "  ";
		}

		if($this->pageCount > 1){
			$strbuf = $strbuf . $lang['commonJumpPage'].' ';
			$strbuf = $strbuf . '<input type="text" class="input4" name="pagenow" id="pagenow"/> ';
			$strbuf = $strbuf . $lang['commonPage'];
			$strbuf = $strbuf . '/'.$lang['commonTotal'].$this->pageCount. $lang['commonPage'].' ';
			$strbuf = $strbuf . '<input class="button" type="button" value="'.$lang['commonOK'].'" onclick="changepage();"/>';
			$strbuf = $strbuf . '<script type="text/javascript">';
			$strbuf = $strbuf . 'function changepage(){';
			$strbuf = $strbuf . 'var page=document.getElementById("pagenow");';
			$strbuf = $strbuf . 'window.location.href="'.substr($actionPath,0,strrpos($actionPath,'&')).'&pagenow="+page.value;}';
			$strbuf = $strbuf . '</script>';
		}

		return $strbuf;
	}
}

?>