<?php
set_magic_quotes_runtime(0);
$mtime = explode(' ', microtime());
$hdwiki_starttime = $mtime[1] + $mtime[0];


if (!file_exists('wikidata/install.lock')) {
	@header("location:install/install.php");
	exit();
}

session_save_path('./wikidata/sessions');
session_cache_limiter('private,must-revalidate');
session_start();

define('HDWIKI_ROOT', substr(dirname(__FILE__), 0, -7));

require HDWIKI_ROOT."./config.inc.php";
require HDWIKI_ROOT."./include/Db.class.php";
require HDWIKI_ROOT."./include/DepartPage.class.php";
require HDWIKI_ROOT."./include/MySmarty.class.php";
require HDWIKI_ROOT."./include/doc.func.php";
require HDWIKI_ROOT."./include/user.func.php";
require HDWIKI_ROOT."./include/plugin.func.php";
require HDWIKI_ROOT."./version.php";

$db =new Db($g_db_host,$g_db_user,$g_db_pwd,$g_db_name,$g_db_charset);

require HDWIKI_ROOT."./include/task.func.php";
require HDWIKI_ROOT."./include/ipban.inc.php";


$cache_setting=getCache('setting');
if(empty($cache_setting)){
	$cache_setting=array();
	$query=$db->query("select * from {$g_table_prefix}setting");
	while($setting=$db->fetch_array($query)){
		$cache_setting[]=$setting;
	}
	writeCache('setting',$cache_setting);
}
for($i=0;$i<count($cache_setting);$i++){
	$tem[$cache_setting[$i]['variable']]=$cache_setting[$i]['value'];
}
$cache_setting=$tem;
unset($tem);

$cache_style=getCache('style');
if(empty($cache_style)){
	$cache_style=array();
	$query=$db->query("select * from {$g_table_prefix}style where state=1");
	while($style=$db->fetch_array($query)){
		$cache_style[]=$style;
	}
	writeCache('style',$cache_style);
}

$cache_lang=getCache('lang');
if(empty($cache_lang)){
	$cache_lang=array();
	$query=$db->query("select * from {$g_table_prefix}lang where state=1");
	while($lang=$db->fetch_array($query)){
		$cache_lang[]=$lang;
	}
	writeCache('lang',$cache_lang);
}

@extract($cache_setting, EXTR_OVERWRITE);
ini_set("display_errors",$site_debug);

$tpl = new MySmarty($tpl_name);
if(substr($time_offset,0,1)=='-'){$time_zone=substr($time_offset,1);}
else{$time_zone='-'.$time_offset;}
ini_set('date.timezone','Etc/GMT'.$time_zone);

$magic_quotes_gpc = get_magic_quotes_gpc();
extract(daddslashes($_COOKIE));
extract(daddslashes($_POST));
extract(daddslashes($_GET));
if(!$magic_quotes_gpc) {
	$_FILES =daddslashes($_FILES);
}



if((!$discuz_passport) && ($discuz_nopassport == "1") && ($action!='settings')){
		require HDWIKI_ROOT."./include/passport.inc.server.php";
		$tpl->assign(array('bbs_passport'=>$discuz_nopassport,'bbs_name'=>$discuz_name,'bbs_url'=>$discuz_url,'formhash'=>$formhash));
}

if($phpwind_passport){
	require HDWIKI_ROOT."./plugins/PhpWind5_3/pw_passport.php";
	$tpl->assign(array('bbs_passport'=>$phpwind_passport,'bbs_name'=>$phpwind_name,'bbs_url'=>$phpwind_url,'formhash'=>$formhash));
}

@$arr_user_info=reloadUser();
$tpl->assign($arr_user_info);

/*
if(empty($docid)){
	if(!empty($_SESSION['doctitle']))
	$arrdocinfo=getDocByTitle($_SESSION['doctitle']);
	$docid=$arrdocinfo['doc_id'];
}
*/

showPlugins('top');

$tpl->assign(array('discuz_passport'=>$discuz_passport,'discuz_name'=>$discuz_name,'discuz_url'=>$discuz_url,'discuz_code'=>$discuz_code));


$article_url=getSEOType("doc.php?action=view&docid=$docid",$seo_type);
$history_url=getSEOType("doc.php?action=history&docid=$docid",$seo_type);
$talk_url=getSEOType("talk.php?docid=$docid",$seo_type);
$doclist_url=getSEOType("doc.php?action=doclist",$seo_type);
$tpl->assign("article_url",$article_url);
$tpl->assign("history_url",$history_url);
$tpl->assign("talk_url",$talk_url);
$tpl->assign("doclist_url",$doclist_url);
$tpl->assign("StyleCache",$cache_style);
$tpl->assign("LangCache",$cache_lang);
if(1==$style_user_select){
	@$user=reloadUser();
	if(1==$user['user_id']&&$cookie_stylename!=''){
		$style_name=$cookie_stylename;
	}elseif(1!=$user['user_id']){
		$style_name=$user['user_style'];
	}
}
if(1==$lang_user_select){
	@$user=reloadUser();
	if(1==$user['user_id']&&''!=$cookie_langname){
		$lang_name=$cookie_langname;
	}elseif(1!=$user['user_id']){
		$lang_name=$user['user_lang'];
	}
}
if(!file_exists(HDWIKI_ROOT."./lang/".$lang_name."/front.php")){
	$lang_name='zh';
}
if(!file_exists(HDWIKI_ROOT."./style/".$style_name."/hdwiki.css")){
	$style_name='default';
}
$tpl->assign("lang_name",$lang_name);
$tpl->assign("style_name",$style_name);
$tpl->assign("lang_user_select",$lang_user_select);
$tpl->assign("style_user_select",$style_user_select);


require HDWIKI_ROOT."./lang/".$lang_name."/front.php";
$tpl->assign("lang",$lang);




function getRadomStr($len = 8)
{
    $str = $chars = '';
	$chars = 'AaBbCcDdEeFfGgHhIiJjKkLlMmNnOoPpQqRrSsTtUuVvWwXxYyZz0123456789';
    $length = strlen( $chars ) - 1;
    srand((double)microtime() * 1000000);
    for ( $i = 0; $i < $len; $i++ )
    {
        $str .= substr($chars, rand( 0, $length ), 1 );
    }
    return $str;
}




function forceMkdir($path) {
  if (!file_exists($path))
	{
		forceMkdir(dirname($path));
	   mkdir($path, 0777);
	}
}




function cleardir($dir,$recursive=false) {
	if(!is_dir($dir))return;
	$directory = dir($dir);
	while ($entry = $directory->read()) {
		$filename = $dir . '/' . $entry;
		if (is_file($filename)) {
			@ unlink($filename);
		}
		elseif($recursive)
		    cleardir($filename);
	}
	$directory->close();
}


function dir_writeable($dir) {
	if(!is_dir($dir)) {
		@mkdir($dir, 0777);
	}
	if(is_dir($dir)) {
		if($fp = @fopen("$dir/test.test", 'w')) {
			@fclose($fp);
			@unlink("$dir/test.test");
			$writeable = 1;
		} else {
			$writeable = 0;
		}
	}
	return $writeable;
}



function readfromfile($filename) {
	if ($fp = @fopen($filename,'rb')) {
		if (PHP_VERSION >= "4.3.0"&&function_exists('file_put_contents')) {
			return file_get_contents($filename);
		} else {
			flock($fp,LOCK_EX);
			$data=fread($fp, filesize($filename));
			flock($fp, LOCK_UN);
    		fclose($fp);
			return $data;
		}
	} else {
		return '';
	}
}


function writetofile($filename,$content)
{
	if ($fp = @fopen($filename,'wb')){
		if (PHP_VERSION >= "4.3.0" && function_exists('file_put_contents')) {
			return file_put_contents($filename,$content);
		}else{
			flock($fp, LOCK_EX);
			$bytes=fwrite($fp, $content);
			flock($fp, LOCK_UN);
			fclose($fp);
			return $bytes;
		}
	}else{
		return 0;
	}
}


function uploadFile($arrfile,$destfile,$maxsize=1024)
{
	global $lang;
	$arrResult=array ('result'=>false,'msg'=>$lang['comUploadWrong']);
	$filesize=$arrfile['size']/1024;
	if($filesize==0)
	{
		$arrResult['msg'] =$lang['comDocWrong'];
		return $arrResult;
	}
	if($filesize>$maxsize)
	{
		$arrResult['msg'] =$lang['comDocLong'];
		return $arrResult;
	}
	$filedir=dirname($destfile);
	forceMkdir($filedir);
	if(copy($arrfile['tmp_name'],$destfile)){
		$arrResult['result']=true;
		return 	$arrResult;
	}else {
		$arrResult['msg']= $lang['comMistake'];
		return $arrResult;
	}
}



function imgReSize($url,$prefix='s_',$width=80,$height=60)
{
	global $lang;
	$arrResult=array ('result'=>false,'tempurl'=>'','msg'=>$lang['comImaCompWrong']);
	if(!file_exists($url)){
		$arrResult['msg'] =$lang['comDocFirst']. $url. $lang['comDocUnexist'];
		return $arrResult;
	}
	$urlinfo=pathinfo($url);
	$ext=strtolower($urlinfo['extension']);
	$tempurl=$urlinfo['dirname'].'/'.$prefix.$urlinfo['basename'];
	if (!preg_match('/^(gif|jpg|jpeg)$/',$ext)) {
		$arrResult['msg'] =$lang['comImaWrong'];
		return $arrResult;
	}

	if(function_exists('gd_info')){
			list($actualWidth,$actualHeight) = getimagesize($url);
			if($actualWidth<$width&&$actualHeight<$height){
				    copy($url,$tempurl);
					$arrResult['tempurl']=$tempurl;
					$arrResult['result']=true;
					return $arrResult;
			}
			if ($actualWidth < $actualHeight){
				$width=($height / $actualHeight) *$actualWidth;
			} else {
				$height=($width/ $actualWidth) *$actualHeight;
			}
			$tempimg=imagecreatetruecolor($width, $height);
			if($ext=='gif'){
				$img = imagecreatefromgif($url);
				imagecopyresampled($tempimg, $img, 0, 0, 0, 0, $width, $height, $actualWidth, $actualHeight);
				$arrResult['result']=imagegif($tempimg, $tempurl, 80);
			}
			else
			{
				$img=imagecreatefromjpeg($url);
				imagecopyresampled($tempimg, $img, 0, 0, 0, 0, $width, $height, $actualWidth, $actualHeight);
				$arrResult['result']=imagejpeg($tempimg, $tempurl, 80);
			}
			imagedestroy($tempimg);
			imagedestroy($img);
			if(file_exists($tempurl)){
				$arrResult['tempurl']=$tempurl;
			}else {
				$arrResult['tempurl']=$url;
			}
	}
	else{
			copy($url, $tempurl);
			if(file_exists($tempurl)){
				$arrResult['result']= true;
				$arrResult['tempurl']=$tempurl;
			}else {
				$arrResult['tempurl']=$url;
			}
	  }
	return $arrResult;
}



function setFirstImg($content)
{
	/*
	preg_match("/<img(.*)src=(\S+){0,2}[^http:\/\/]{7}(\S+)(\s+)(.*)>/i",$content,$imgs);
	$tempurl = str_replace("\\\"","",$imgs[2]);
	$tempurl= str_replace("\\'","",$tempurl);
	$tempurl = str_replace("\"","",$tempurl);
	$tempurl = str_replace("\'","",$tempurl);
	return $tempurl;
	*/
	preg_match_all("/<img.+src=\\\\\"(.+?)\\\\\"/i",$content,$imgs);
	$imgs=$imgs[1];
	$tempurl='';
  	foreach($imgs as $img){
		$img=urldecode($img);
		//$img=strtolower($img);
        if(substr($img,0,7)!='http://')
		{
			if (!empty($img))
			{
				//$img=str_replace ("\\\"","",$img);
				$arrResult=imgReSize($img,'f_');
				$tempurl=$arrResult['tempurl'];
				break;
			}
		}
	}
	return $tempurl;
}





function checkEmailFormat( $value , $msg=''){
	global $errors;
	if( !eregi( "^[0-9a-z~'!#$%&_-]([.]?[0-9a-z~!#$%&_-])*" .
	"@[0-9a-z~!#$%&_-]([.]?[0-9a-z~!#$%&_-])*$" , $value ) ){
		$errors++;
		return $msg;
	}
	else
	return null;
}


function checkEmail( $email , $msg='' ){
	global $errors,$db,$g_table_prefix;
	$arr_email_sql=" SELECT * FROM {$g_table_prefix}user WHERE user_email='".strtolower($email)."'";
	$query=$db->query($arr_email_sql);
   $user_info = $db->fetch_array($query);
	if(is_array($user_info)){
		$errors++;
		return $msg;
	}
	else
	return null;
}


function checkPassWord( $pwd , $re_pwd , $msg=''){
	global $errors;
	if( $pwd != $re_pwd ){
		$errors++;
		return $msg;
	}
	else
	return null;
}


function checkLoginInfo( $arr_loginInfo){
	global $db,$g_table_prefix;
	$user_email=strtolower($arr_loginInfo['user_email']);
	$user_password=md5($arr_loginInfo['user_password']);
	$sql="select * from {$g_table_prefix}user u,{$g_table_prefix}usergroup g where u.user_email='{$user_email}' and u.user_password='{$user_password}' and u.state=1 and u.usergroup_id=g.usergroup_id";
	$res=$db->query($sql);
	return $db->fetch_array($res);
}


function checkPasswordIsError( $password , $msg="" ){
	global $errors;
	if( md5( $password ) !== $_SESSION['arr_user_info']['user_password'] ){
		$errors++;
		return $msg;
	}
	else
	return null;
}

function checkNickName( $nickname , $msg="" ){
	global $errors,$db,$g_table_prefix;
	$arr_nick_sql = " SELECT * FROM {$g_table_prefix}user WHERE user_nick_upper='".hstrtoupper($nickname)."'";
	$query=$db->query($arr_nick_sql);
	$user_info = $db->fetch_array($query);
	if(is_array($user_info)){
		$errors++;
		return $msg;
	}
	else
	return null;
}


function checkVerification( $code , $msg="" ){
	global $errors;
	if( $code != $_SESSION['verification'] ){
		$errors++;
		unset($_SESSION['verification']);
		return  $msg;
	}
	else
	return null;
}


function checkAgree( $value , $msg="" ){
	global $errors;
	if( !$value ){
		$errors++;
		return $msg;
	}
	else
	return null;

}


function checkLength( $value , $max , $min , $msg="" ){
	global $errors;
	if( strlen( $value )>$max || strlen( $value )<$min ){
		$errors++;
		return $msg;
	}
	else
	return null;
}


function checkIsNull( $value , $msg="" ){
	global $errors;
	if( !isset( $value ) || empty( $value ) || $value == '' ){
		$errors++;
		return  $msg;
	}
	else
	return null;
}


function checkFileExName( $arr_file_ex_names , $filename , $msg="" ){
	global $errors;
	foreach( $arr_file_ex_names as $key => $value ){
		if( $value == strtolower(substr( $filename, -3 )) || $value == strtolower(substr( $filename, -4 )) ){
			return null;
		}
	}
	$errors++;
	return $msg;
}


function subString($text, $start=0, $limit=12) {
    global $g_db_charset;
    $encoding=$g_db_charset;
         if(strtolower($encoding)=='gbk'){

		     $strlen=strlen($text);
		     if ($start>=$strlen)return $text;
		     $clen=0;
		     for($i=0;$i<$strlen;$i++,$clen++)
		     {
		        if(ord(substr($text,$i,1))>0xa0)
		        {
		          if ($clen>=$start)$tmpstr.=substr($text,$i,2);
		          $i++;
		         }
		         else
		         {
		            if ($clen>=$start)$tmpstr.=substr($text,$i,1);
		         }
		        if ($clen>=$start+$limit)break;
		    }
		    $text=$tmpstr;
         }else{

			    $patten = "/[\x01-\x7f]|[\xc2-\xdf][\x80-\xbf]|\xe0[\xa0-\xbf][\x80-\xbf]|[\xe1-\xef][\x80-\xbf][\x80-\xbf]|\xf0[\x90-\xbf][\x80-\xbf][\x80-\xbf]|[\xf1-\xf7][\x80-\xbf][\x80-\xbf][\x80-\xbf]/";
			    preg_match_all($patten, $text, $regs);
			    $v = 0; $s = '';
			    for($i=0; $i<count($regs[0]); $i++)
				{
			        (ord($regs[0][$i]) > 129) ? $v += 2 : $v++;
			        $s .= $regs[0][$i];
					if($v >= $limit * 2)
					{
						break;
				    }
				}
			    $text=$s;
         }
		return $text;
}



function hiconv($s,$to='',$from='') {
    global $g_db_charset;
    if(empty($to))$to=$g_db_charset;
    if(empty($from)){
	    if(strtolower($g_db_charset)=='gbk'){$from='utf-8';}else{$from='gbk';}
    }
    $isutf8=preg_match( '/^([\x00-\x7f]|[\xc0-\xdf][\x80-\xbf]|[\xe0-\xef][\x80-\xbf]{2}|[\xf0-\xf7][\x80-\xbf]{3})+$/', $s );
	if( $isutf8 && $to=='utf-8' ) return $s;
	if( !$isutf8 && $to=='gbk' ) return $s;
	require_once(HDWIKI_ROOT.'./include/Chinese.class.php');
	$ch = new Chinese($from,$to);
	$s= $ch->Convert($s);
	return $s;
}


function daddslashes(&$string, $force = 0) {
	if(!$GLOBALS['magic_quotes_gpc'] || $force) {
		if(is_array($string)) {
			foreach($string as $key => $val) {
				$string[$key] = daddslashes($val, $force);
			}
		}else {
			$string = addslashes($string);
		}
	}
	return $string;
}


function stripslashes_array(&$array) {
	while(@list($key,$var) = @each($array)) {
		if ($key != 'argc' && $key != 'argv' && (strtoupper($key) != $key || ''.intval($key) == "$key")) {
			if (is_string($var)) {
				$array[$key] = stripslashes($var);
			}
			if (is_array($var))  {
				$array[$key] = stripslashes_array($var);
			}
		}
	}
	return $array;
}


function convertIP($ip){
	$arr_ip=explode(".",$ip);
	return $arr_ip[0].'.'.$arr_ip[1].'.'.$arr_ip[2].'.*';
}


function hstrtoupper($str)
{
	$i=0;
	$total = strlen($str);
	$restr = '';
	for ($i=0; $i<$total; $i++)
	{
		$str_acsii_num = ord($str[$i]);
		if($str_acsii_num>=97 AND $str_acsii_num<=122)
		{
			$restr.=chr($str_acsii_num-32);
		}
		else
		{
			$restr.=chr($str_acsii_num);
		}
	}
	return $restr;
}




function doHelp()
{
	/*global $tpl,$db,$g_table_prefix;

   $helpsections=getCache('helpsections',-1);
	if(empty($helpsections)){
		$query = $db->query(" select doc_id,doc_content from {$g_table_prefix}doc where doc_id=2");
		$doc=$db->fetch_array($query);
		$arrhtml=splitHtml($doc['doc_content']);
		$helpsections=getSections($arrhtml);
		writeCache('helpsections',$helpsections);
	}

	$tpl->assign('helpsections',$helpsections);*/
}


function stripSpecialCharacter($string) {
	$string=trim($string);
	$string=str_replace("&","",$string);
	$string=str_replace("\'","",$string);
	$string=str_replace("'","",$string);
	$string=str_replace("&amp;amp;","",$string);
	$string=str_replace("&amp;quot;","",$string);
	$string=str_replace("\"","",$string);
	$string=str_replace("&amp;lt;","",$string);
	$string=str_replace("<","",$string);
	$string=str_replace("&amp;gt;","",$string);
	$string=str_replace(">","",$string);
	$string=str_replace("&amp;nbsp;","",$string);
	$string=nl2br($string);
	return $string;
}


function stripEmptyHtml($matches){
	$arr_tags1=explode(" ",$matches[1]);
	if ($arr_tags1[0]==$matches[2]){
		return "";
	}else{
		$matches[0]=str_replace("<","[html_&lt;]",$matches[0]);
		$matches[0]=str_replace(">","[html_&gt;]",$matches[0]);
		return $matches[0];
	}
}


function makeXMLByArr($arrXMLData,$arrEleName,$rootEleName='ROOT',$recordEleName='RECORD'){
	global $g_db_charset;

	$xmlstr='';
	$CDATABeg='<![CDATA[';
	$CDATAEnd=']]>';

	$xmlstr=$xmlstr.'<?xml version="1.0" encoding="'.$g_db_charset.'"?><'.$rootEleName.'>';

	for($i=0;$i<count($arrXMLData);$i++){
		$xmlstr=$xmlstr.'<'.$recordEleName.'>';
		for($j=0;$j<count($arrEleName);$j++)
			$xmlstr=$xmlstr.'<'.$arrEleName[$j].'>'.$CDATABeg.$arrXMLData[$i][$arrEleName[$j]].$CDATAEnd.'</'.$arrEleName[$j].'>';
		$xmlstr=$xmlstr.'</'.$recordEleName.'>';
	}

	$xmlstr=$xmlstr.'</'.$rootEleName.'>';

	return $xmlstr;
}


function getArrByXML($xmlFileName,$arrEleName,$rootEleName='ROOT',$recordEleName='RECORD'){
	require_once HDWIKI_ROOT."./include/kxparse.php";
	$xmlObj=new kxparse($xmlFileName);
	$xmlEleSum = $xmlObj->count_element($rootEleName.':?','1:?');
	$xmlEleItemSum=count($arrEleName);
	$arrXMLData=array();
	$arrXMLEleData=array();

	for($i=0;$i<$xmlEleSum;$i++){
		for($j=0;$j<$xmlEleItemSum;$j++){
			$arrXMLEleData[$arrEleName[$j]]=hiconv(($xmlObj->get_tag_text($rootEleName.':'.$recordEleName.':'.$arrEleName[$j],'1:'.($i+1).':1')));
		}
		array_push($arrXMLData,$arrXMLEleData);
	}
	return $arrXMLData;

}


function array_remove($delindex,$arr){
	if($delindex>count($arr)){return $arr;}
    for($i=0,$n=0;$i<count($arr);$i++){
        if($i!=$delindex)
        {
            $arr[$n++]=$arr[$i];
        }
    }
    array_pop($arr);
    return $arr;
}




function getJoinStr($xiabiao,$arr,$splitchar){
	$strjoin='';
	for($i=0;$i<count($arr);$i++){
		if(!is_null($xiabiao))
			$strjoin=$strjoin.$arr[$i][$xiabiao].$splitchar;
		else
			$strjoin=$strjoin.$arr[$i].$splitchar;
	}
	return $strjoin;
}

function getSEOType($url,$seotype){
//	if($seotype=="1"){
//		$arr_url_tem=explode("?",$url);
//		$url=substr($arr_url_tem[0],0,-4);
//		$arr_url_tem1=explode("&",$arr_url_tem[1]);
//		foreach($arr_url_tem1 as $str_url_tem1){
//			$num=strpos($str_url_tem1,"=");
//			$url .="-".substr($str_url_tem1,($num+1));
//		}
//		if(substr($url,0,12)=='doc-doclist-')
//		{
//			$url="list".substr($url,3);
//		}
//		$url="wiki.php/".$url.".html";
//		return $url;
//	}
	if($seotype=="2"){
		$arr_url_tem=explode("?",$url);
		$url=substr($arr_url_tem[0],0,-4);
		$arr_url_tem1=explode("&",$arr_url_tem[1]);
		foreach($arr_url_tem1 as $str_url_tem1){
			$num=strpos($str_url_tem1,"=");
			$url .="-".substr($str_url_tem1,($num+1));
		}
		/*if(substr($url,0,12)=='doc-doclist-')
		{
			$url="list".substr($url,3);
		}*/
		$url=$url.".html";
		return $url;
	}
	else{
		return $url;
	}
}

function getCatList($catlist,$oldcat,$depth=1)
{
	global $pcid;
	/*if($oldcat['cat_parent']==0&&$oldcat['state']==1)
    {
    	$selected=($oldcat['cat_id']==$pcid)?" selected ":"";
    	$str .= "<option value=\"{$oldcat['cat_id']}\"{$selected}>{$oldcat['cat_name']}</option>";
    }*/
	foreach($catlist as $cat)
	{
		if($oldcat['cat_id']==$cat['cat_parent']&&$cat['state']==1)
		{
			$selected=($cat['cat_id']==$pcid)?" selected ":"";
			$str .= "<option value=\"{$cat['cat_id']}\"{$selected}>";
			$depthstr=str_repeat("--", $depth);
			$str .= $depth ? "&nbsp;&nbsp;|{$depthstr}&nbsp;{$cat['cat_name']}</option>" :"{$cat['cat_name']}</option>";
			$str .= getCatList($catlist, $cat,$depth+1);
		}
	}

    return $str;
}

function getAllCatList($arr_catlist)
{
	$str='';
	global $pcid;
	for($i=0;$i<count($arr_catlist);$i++)
	{
		if($arr_catlist[$i]['cat_parent']==0&&$arr_catlist[$i]['state']==1)
		{

		    $selected=($arr_catlist[$i]['cat_id']==$pcid)?" selected ":"";
		    $str .= "<option value=\"{$arr_catlist[$i]['cat_id']}\"{$selected}>{$arr_catlist[$i]['cat_name']}</option>";
			$str .=getCatList($arr_catlist,$arr_catlist[$i],1);
		}

	}
	return $str;
}


function getCatReordering($catlist,$oldcat,$depth=1)
{
	/*if($oldcat['cat_parent']==0&&$oldcat['state']==1)
    {
    	$cidorder .= $oldcat['cat_id'].",";
    }*/
	for($i=0;$i<count($catlist);$i++)
	{
		if($oldcat['cat_id']==$catlist[$i]['cat_parent']&&$catlist[$i]['state']==1)
		{
			$cidorder .=$catlist[$i]['cat_id']."+{$depth},";
			$cidorder .=getCatReordering($catlist, $catlist[$i],$depth+1);
		}
	}
    return $cidorder;
}

function getCatTree(){
	global $db,$g_table_prefix;
	$query=$db->query("select * from {$g_table_prefix}categorie where state=1 order by cat_order asc");
	while($cat=$db->fetch_array($query)){
		$typelist[]=$cat;
	}
	return getAllCatList($typelist);
}


function getCatNav($catid)
{
	global $db,$g_table_prefix;
	$query=$db->query("select cat_navi from {$g_table_prefix}categorie where cat_id=".$catid);
	$dbcatnavi=$db->fetch_array($query);
	$arr_catnavi=unserialize($dbcatnavi['cat_navi']);
	for($i=0;$i<count($arr_catnavi);$i++){
		$str_catnavi .="<a href=\"catnavi.php?action=catinfo&cid=".$arr_catnavi[$i]['cat_id']."\" >".$arr_catnavi[$i]['cat_name']."</a> &raquo; ";
	}
	return substr($str_catnavi,0,-8);
}

function catReordering($arr_catlist)
{
	$cidorder='';
	for($i=0;$i<count($arr_catlist);$i++)
	{
		if($arr_catlist[$i]['cat_parent']==0&&$arr_catlist[$i]['state']==1)
		{

		    $cidorder .= $arr_catlist[$i]['cat_id'].",";
			$cidorder .=getCatReordering($arr_catlist,$arr_catlist[$i],1);
		}
	}
	$arr_cat=explode(",",substr($cidorder,0,-1));
	for($i=0;$i<count($arr_cat);$i++)
	{
		$tem=explode('+',$arr_cat[$i]);
		for($j=0;$j<count($arr_catlist);$j++)
		{
			if($tem[0]==$arr_catlist[$j]['cat_id']&&$arr_catlist[$j]['state']==1)
			{
				$depthstr=str_repeat("----", $tem[1]);
				$depthstr=$depthstr?"&nbsp;&nbsp;|{$depthstr}&nbsp;":"";
				$arr_catlist[$j]['cat_name']=$depthstr.$arr_catlist[$j]['cat_name'];
				$tem_arr[]=$arr_catlist[$j];
			}
		}
	}
	return $tem_arr;
}

function convert_character($str){

	$str=str_replace("\r","",$str);
	$str=str_replace("\n","",$str);
	$str=str_replace("'","&#39;",$str);
	$str=addslashes($str);
	return $str;

}


function   ubb($Text){
	$Text=str_replace("&","&amp;",$Text);
	$Text=str_replace("'","&#39;",$Text);
	$Text=str_replace("&amp;amp;","&amp;",$Text);
	$Text=str_replace("&amp;quot;","&quot;",$Text);
	$Text=str_replace("\"","&quot;",$Text);
	$Text=str_replace("&amp;lt;","&lt;",$Text);
	$Text=str_replace("<","&lt;",$Text);
	$Text=str_replace("&amp;gt;","&gt;",$Text);
	$Text=str_replace(">","&gt;",$Text);
	$Text=str_replace("&amp;nbsp;","&nbsp;",$Text);
	$Text=str_replace("&lt;!--","<!--",$Text);
	$Text=str_replace("--&gt;","-->",$Text);

	$Text=stripslashes($Text);
	$Text=ereg_replace("\r\n","<br>",$Text);
	$Text=ereg_replace("\r","<br>",$Text);
	$Text=nl2br($Text);
	$Text=preg_replace("/\\t/is","     ",$Text);
	$Text=ereg_replace("   ","?",$Text);

	$Text=preg_replace("/\[h1\](.+?)\[\/h1\]/is","<h1>\\1</h1>",$Text);
	$Text=preg_replace("/\[h2\](.+?)\[\/h2\]/is","<h2>\\1</h2>",$Text);
	$Text=preg_replace("/\[h3\](.+?)\[\/h3\]/is","<h3>\\1</h3>",$Text);
	$Text=preg_replace("/\[h4\](.+?)\[\/h4\]/is","<h4>\\1</h4>",$Text);
	$Text=preg_replace("/\[h5\](.+?)\[\/h5\]/is","<h5>\\1</h5>",$Text);
	$Text=preg_replace("/\[h6\](.+?)\[\/h6\]/is","<h6>\\1</h6>",$Text);
	$Text=preg_replace("/\[center\](.+?)\[\/center\]/is","<center>\\1</center>",$Text);
	$Text=preg_replace("/\[big\](.+?)\[\/big\]/is","<big>\\1</big>",$Text);
	$Text=preg_replace("/\[small\](.+?)\[\/small\]/is","<small>\\1</small>",$Text);

	$Text=preg_replace("/\[url\](http:\/\/.+?)\[\/url\]/is","<a   href=\\1>\\1</a>",$Text);
	$Text=preg_replace("/\[url\](.+?)\[\/url\]/is","<a   href=\'http://\\1\'>http://\\1</a>",$Text);
	$Text=preg_replace("/\[url=(http:\/\/.+?)\](.*)\[\/url\]/is","<a   href=\\1>\\2</a>",$Text);
	$Text=preg_replace("/\[url=(.+?)\](.*)\[\/url\]/is","<a   href=http://\\1>\\2</a>",$Text);

	$Text=preg_replace("/\[img\](.+?)\[\/img\]/is","<img alt=\"\"   src=\\1   border=0 />",$Text);
	$Text=preg_replace("/\[img=(.+?)\]\[\/img\]/is","<img alt=\"\"   src=\\1   border=0 />",$Text);
	$Text=preg_replace("/\[img=(.+?)\](.+?)\[\/img\]/is","<img alt=\\2  src=\\1   border=0 />",$Text);
	$Text=preg_replace("/\[color=(.+?)\](.+?)\[\/color\]/is","<font   color=\\1>\\2</font>",$Text);
	$Text=preg_replace("/\[size=(.+?)\](.+?)\[\/size\]/is","<font   size=\\1>\\2</font>",$Text);
	$Text=preg_replace("/\[sup\](.+?)\[\/sup\]/is","<sup>\\1</sup>",$Text);
	$Text=preg_replace("/\[sub\](.+?)\[\/sub\]/is","<sub>\\1</sub>",$Text);
	$Text=preg_replace("/\[pre\](.+?)\[\/pre\]/is","<pre>\\1</pre>",$Text);
	$Text=preg_replace("/\[email\](.+?)\[\/email\]/is","<a   href=mailto:\\1>\\1</a>",$Text);
	$Text=preg_replace("/\[i\](.+?)\[\/i\]/is","<i>\\1</i>",$Text);
	$Text=preg_replace("/\[b\](.+?)\[\/b\]/is","<b>\\1</b>",$Text);
	$Text=preg_replace("/\[u\](.+?)\[\/u\]/is","<u>\\1</u>",$Text);
	$Text=preg_replace("/\[quote\](.+?)\[\/quote\]/is","<blockquote><font   size='3'   face='Courier   New'>quote:</font><hr>\\1<hr></blockquote>",   $Text);
	$Text=preg_replace("/\[code\](.+?)\[\/code\]/is","<blockquote><font   size='3'   face='Times   New   Roman'>code:</font><hr   color='lightblue'><i>\\1</i><hr   color='lightblue'></blockquote>",   $Text);
	$Text=preg_replace("/\[sig\](.+?)\[\/sig\]/is","<div   style='text-align:   left;   color:   darkgreen;   margin-left:   5%'><br><br>--------------------------<br>\\1<br>--------------------------</div>",   $Text);
	$Text=ereg_replace("\[hr\]","<hr>",$Text);
	$Text=preg_replace("/\[em([0-1][0-9])\]/is","<img alt=\"\" src=\"style/icon/em\\1.gif\" border=\"0\"/>",$Text);
	$Text=preg_replace("/\[em(2[0-5])\]/is","<img alt=\"\" src=\"style/icon/em\\1.gif\" border=\"0\"/>",$Text);
	return   $Text;
}

function createServerTime($time='',$timformat='Y-m-d H:i:s'){
	global $timediff;
	if($time==''){
		$time=time();
	}
    return date($timformat, $time + ($timediff * 60));
}

function formatTime($timestring,$format='datetime'){
	global $arr_user_info,$time_offset,$date_format,$time_format;
	if('date'==$format){
		$formatstr=$date_format;
	}elseif('time'==$format){
		$formatstr=$time_format;
	}else{
		$formatstr=$date_format." ".$time_format;
	}
	$returntime = date($formatstr,strtotime($timestring)+($arr_user_info['user_time_offset']-$time_offset)*3600);
	return $returntime;
}

function createHotTags(){
	global $tpl,$db,$g_table_prefix;
	$query=$db->query("select hottag_name, hottag_count from {$g_table_prefix}hottag group by hottag_name order by hottag_count desc limit 0,30");
	while($hottag=$db->fetch_array($query)){
		$hottaglist[]=$hottag;
	}
	unset($hottag);
	return $hottaglist;
}




function writeCache($cachename,$data){
 	forcemkdir('./wikidata/cache');
	$bytes=writetofile('./wikidata/cache/cache_'.$cachename.'.php',serialize($data));
	if($bytes==0) exit('can not write cache '.$cachename);
}


function getCache($cachename,$cachetime=30000){
	 if($cachetime==-1)return '';
	 $cachefile='./wikidata/cache/cache_'.$cachename.'.php';
	 if (is_readable($cachefile)){
	 	clearstatcache();
		if((time()-filemtime($cachefile))< $cachetime){
			$contents=readfromfile($cachefile);
			return unserialize($contents);
		}
	 }
	return '';
}


function removeCache($cachename){
	$filename='./wikidata/cache/cache_'.$cachename.'.php';
	if(file_exists($filename)){
		unlink($filename);
	}
}

?>