<?php
function splitHtml($html,$preg='/(<div\s+class=\"?hdwiki_tmml\"?>.+?<\/div>)/i')
{
	$arrhtml=preg_split($preg,$html,-1,PREG_SPLIT_DELIM_CAPTURE);
	$count=count($arrhtml);
	for($i=0;$i<$count;$i++)
	{
		if(preg_match($preg,$arrhtml[$i])){
			$resarr[$i]['value']=strip_tags($arrhtml[$i]);
			$resarr[$i]['flag']=1;
			continue;
		}
		$resarr[$i]['value']=$arrhtml[$i];
		$resarr[$i]['flag']=0;
	}
	unset($arrhtml);
	return $resarr;
}


function joinHtml($arrhtml)
{
	$count=count($arrhtml);
	$str='';
	for($i=0;$i<$count;$i++)
	{
		if($arrhtml[$i]['flag']==1)
		{
			$str.="<div class=\"hdwiki_tmml\">".$arrhtml[$i]['value']."</div>";
		}else {
			$str.=$arrhtml[$i]['value'];
		}
	}
	return $str;
}


function getSections($resarr)
{
	$arrsection=array();
	for($i=0;$i<count($resarr);$i++)
	{
		if($resarr[$i]['flag']==1)
		{
			$arrsection[]=array('key'=>$i,'value'=>$resarr[$i]['value']);
		}
	}
	unset($resarr);
	return $arrsection;
}

function  getDocById( $id )
{
	global $g_table_prefix,$db;
	$query=$db->query("select * from {$g_table_prefix}doc where doc_id ={$id} ");
	return $db->fetch_array($query);
}

function  getDocByTitle( $title )
{
	$title=hstrtoupper($title);
	global $g_table_prefix,$db;
	$query = $db->query( " select * from {$g_table_prefix}doc where doc_title_upper ='{$title}' " );
	$arr_doc_info=$db->fetch_array($query);
	return $arr_doc_info;
}


function spiltTags($doc_tags)
{
	$tags=split(';',$doc_tags) ;
	$arrTags=array();
	foreach ($tags as $tag)
	{
		if(!empty($tag))
		{
			$arrTags[]=$tag;
		}
	}
	return $arrTags;
}


function joinTags($arrTags)
{
	$arrRes=array();
	foreach ($arrTags as $tag)
	{
		if(!empty($tag))
		{
			$arrRes[]=trim($tag);
		}
	}
	return implode(';',array_unique($arrRes));
}


function  getDocUserList($docid)
{
	global $g_table_prefix,$db;
	$sql= " SELECT max( his_created_time ) AS edit_time, his_creator, count( his_id ) AS edit_count,b.*
			FROM {$g_table_prefix}his  a
			left join  {$g_table_prefix}user  b
			on a.his_creator = b.user_id
			where a.doc_id={$docid}
		    GROUP BY his_creator
			ORDER BY edit_time DESC ";
	$query=$db->query($sql);

	while($userhisinfo=$db->fetch_array($query)){
		$userhisinfo['edit_time']=formatTime($userhisinfo['edit_time']);
		$arr_doc_user_info[] = $userhisinfo;
	}

	return @$arr_doc_user_info;
}


function  getDocHisList($docid,$limit=''){
	global $g_table_prefix,$db;
	$sql= "SELECT h.his_created_time, h.his_creator, h.his_id, h.doc_edition_no, h.his_kind, h.his_reason,h.state,h.his_great,h.doc_id,u.user_nick
		   FROM {$g_table_prefix}his AS h left join {$g_table_prefix}user u
		   on  h.his_creator=u.user_id
		   WHERE h.doc_id ={$docid}
		   ORDER BY his_id DESC ";
	if($limit) $sql .= " LIMIT 0,$limit";
	$query=$db->query($sql);

	while($dochisinfo=$db->fetch_array($query)){
		$dochisinfo['his_created_time']=formatTime($dochisinfo['his_created_time']);
		$arr_doc_hislst_info[] = $dochisinfo;

	}

	return @$arr_doc_hislst_info;
}


function  getDocHisInfo($hisid)
{
	global $g_table_prefix,$db;
	$sql= " SELECT h.*,u.user_nick
			FROM {$g_table_prefix}his h, {$g_table_prefix}user u
			WHERE h.his_id={$hisid}
			AND h.state=1
			AND u.user_id=h.his_creator ";
	$query=$db->query($sql);

	$arr_doc_his_info=$db->fetch_array($query);

	return $arr_doc_his_info;
}

function  getDocHisCompare($hisnewid,$hisoldid)
{
	global $g_table_prefix,$db;
	$sql= " SELECT h.*,u.user_nick
			FROM {$g_table_prefix}his h, {$g_table_prefix}user u
			WHERE h.his_id
			IN ({$hisnewid},{$hisoldid})
			AND h.state=1
			AND u.user_id=h.his_creator";
	$query=$db->query($sql);

	while($dochisinfo=$db->fetch_array($query)){
		$arr_doc_his_info[]=$dochisinfo;
	}

	return $arr_doc_his_info;
}



function lateEditorList($doc_id,$limit='')
{
	global $g_table_prefix,$db;
	$sql= " SELECT max( his_created_time )AS edit_time,u.user_id,u.user_nick,u.user_small_ico,u.user_big_ico
			FROM {$g_table_prefix}his AS h left join  {$g_table_prefix}user u
			on  h.his_creator=u.user_id
			WHERE h.doc_id ={$doc_id}
			GROUP BY his_creator
			ORDER BY edit_time DESC ";
	if($limit) $sql .= " LIMIT 0,$limit";
	$query=$db->query($sql);

	while($userinfo=$db->fetch_array($query)){
		$user_list[]=$userinfo;
	}

	return $user_list;
}



function  getAttendeeCount($doc_id,$his_creator)
{
	global $g_table_prefix,$db;

	$query=$db->query(" SELECT count(distinct his_creator) as num from {$g_table_prefix}his  where doc_id={$doc_id}  and  his_creator!={$his_creator} and  state=1 ");

	return $db->result($query,0);
}

/*
function recentChangeList()
{
	global $g_table_prefix,$db;
	$sql = 	" SELECT d.*,u.user_nick,u.user_id,u.user_small_ico
			  FROM  {$g_table_prefix}user u,{$g_table_prefix}doc d
			  WHERE u.user_id = d.doc_creator
			  AND d.state=1
			  ORDER BY d.doc_latest_edition_time DESC ";
	$db->execQuery( $sql );
	if($db->getNumRows()>0){
		$doc_list = $db->fetchArrayN(20);
	}
	return $doc_list;
}
*/

function getInterval($opt='ulcdt',$msg='',$jumpurl)
{
	global $tpl,$lang;
	@$tval=$_SESSION[$opt];
	if(!empty($tval))
	{
		$interval=time()-$tval;
		if($interval<10)
		{
			$tpl->assign('errorhtml',$msg.$lang['docFuncDefault'].(10-$interval).$lang['docFuncTimes'].$msg.$lang['docFuncGan']);
			$tpl->assign('jumpurl',$jumpurl);
			$tpl->assign('interval',10-$interval);
			doHelp();
			$tpl->display('errors');
			exit();
		}
	}
}

function setInterval($opt='ulcdt'){
	$_SESSION[$opt]=time();
}


function checkEditRight(){
	global $tpl,$user,$lang;
	if($user['allow_edit']!=1){
		$tpl->assign('errorhtml',$lang['editDocNoRights']);
		if($user['user_id']!=1){
			$tpl->assign('jumpurl','javascript:history.go(-1)');
		}
		else{
			$tpl->assign('jumpurl','logging.php');
		}
		doHelp();
		$tpl->display('errors');
		exit();
	}
}

?>