<?php
function plugin_basename($file) {
	$file = preg_replace('|\\\\+|', '\\\\', $file);
	$file = preg_replace('/^.*..[\\\\\/]plugins[\\\\\/]/', '', $file);
	return $file;
}


function get_plugins($basedir) {
	$plugins = array ();
	$plugin_files = array();

    $handle=opendir($basedir);
    while ($file = readdir($handle)){
    $filename=$basedir."/".$file."/".$file.".php";
		if (is_dir($basedir."/".$file) && $file!="." && $file!=".." && file_exists($filename)){
			if ( !is_readable("$basedir/$plugin_file"))
			continue;

			$plugin_data = get_plugin_data($filename);

			if (empty ($plugin_data['Name'])) {
				continue;
			}
			$plugin_data['filename']=$file;
			$plugin_data['filepath']=$filename;
			$plugins[] = $plugin_data;
			}
    }
    closedir($handle);

	return $plugins;
}

function get_plugin_data($plugin_file) {
	global $strVisitPluginHomepage;
	$plugin_data = readfromfilenew($plugin_file);
	preg_match("|Plugin Name:(.*)|i", $plugin_data, $plugin_name);
	preg_match("|Plugin URI:(.*)|i", $plugin_data, $plugin_uri);
	preg_match("|Description:(.*)|i", $plugin_data, $description);
	preg_match("|Author:(.*)|i", $plugin_data, $author_name);
	preg_match("|Author URI:(.*)|i", $plugin_data, $author_uri);
	if (preg_match("|Version:(.*)|i", $plugin_data, $version))
		$version = $version[1];
	else
		$version = '';

	$description = $description[1];

	$name = $plugin_name[1];
	$name = trim($name);
	$plugin = $name;

	if (!empty($plugin_uri[1]) && !empty($name)) {
		$plugin = $plugin;
	}

	if (empty($author_uri[1])) {
		$author = $author_name[1];
	} else {
		$author = '<a target=_blank href="'.$author_uri[1].'" title="'.$strVisitPluginHomepage.'">'.$author_name[1].'</a>';
	}

	$arr=explode("/",$plugin_file);
	$plugin_root=$arr[0]."/".$arr[1]."/".$arr[2];
	$pfile=$arr[3];

	if (file_exists($plugin_root.'/setting.php')) {
		$setting="setting.php";
	} else {
		$setting="";
	}

	if (file_exists($plugin_root.'/advanced.php')) {
		$advanced="advanced.php";
	} else {
		$advanced="";
	}

	return array ('Name' => $name, 'Title' => $plugin, 'Description' => $description, 'Author' => $author, 'Version' => $version, 'Setting' => $setting ,'Advanced' => $advanced ,'Pfile' => $pfile);
}


function readfromfilenew($file_name) {
	if (file_exists($file_name)) {
			$filenum=fopen($file_name,"rb");
			$sizeofit=filesize($file_name);
			if ($sizeofit<=0) return '';
			flock($filenum,LOCK_EX);
			$file_data=fread($filenum, $sizeofit);
			fclose($filenum);
			return $file_data;
	} else {
		return '';
	}
}

function install_plugins($arr) {
	global $db, $g_table_prefix,$lang;
	$category=isset($arr['Type'])?trim($arr['Type']):"";
	$desc=isset($arr['Desc'])?trim($arr['Desc']):"";
	$pluginname=isset($arr['Name'])?trim($arr['Name']):"";
	$htmlcode=isset($arr['Code'])?trim($arr['Code']):"";

	if($category=="")
	$category="top";
	if($pluginname=="")
	{
		echo $lang['pluginName'];
		exit();
	}


	$sql="select count(*) total from {$g_table_prefix}plugin where state=1 and plug_name='$pluginname'";
	$query=$db->query($sql);
	$arr_plugins=$db->fetch_array($query);
	if($arr_plugins[total]>0)
 	{
 		echo  $lang['pluginInstall'];
		exit();
	}
	$plugpath="./plugins/".$pluginname."/".$pluginname.".php";
  	$nowdate=time();
 	$sql="insert into  {$g_table_prefix}plugin (plug_name,plug_descripe,plug_path,plug_status,plug_type,plug_dateline,state) values ('$pluginname','$desc','$plugpath',0,'$category','$nowdate',1)";
	$db->query($sql);

}
function unstall_plugins($pluginname) {
	global $db, $g_table_prefix,$lang;
	if($pluginname=="")
	{
		echo $lang['pluginParaWrong'];
		exit();
	}
	$sql="update {$g_table_prefix}plugin set state=2 where plug_name='{$pluginname}'";
	$db->query($sql);
}



function showPlugins($plugin_type='top')
{
	global $tpl,$db,$g_table_prefix;

	$plugin_list_name='plugins_'.$plugin_type.'_list';

	$plugins=getCache('plugins');
	if(empty($plugins)){
		$query=$db->query("select * from {$g_table_prefix}plugin where state=1 and plug_status=1");
		while($plugin=$db->fetch_array($query)){
			$plugins[]=$plugin;
		}
		writeCache('plugins',$plugins);
	}
	if(!empty($plugins)){
		foreach ($plugins as $plugin){
			if($plugin['plug_type']==$plugin_type){
				include_once($plugin['plug_path']);
			 	$plugin_list[]=call_user_func($plugin['plug_name'],$plugin);
			}
		}
	}
	$tpl->assign($plugin_list_name,$plugin_list);
}



?>