-- Table: wiki_attachment
DROP TABLE IF EXISTS wiki_attachment;
CREATE TABLE wiki_attachment (
  attach_id int(12) unsigned auto_increment NOT NULL,
  doc_id int(12) unsigned NOT NULL,
  attach_title varchar(250) NOT NULL,
  attach_creator int(12) unsigned NOT NULL,
  attach_ip varchar(32) NOT NULL,
  attach_time datetime NOT NULL default '0000-00-00 00:00',
  attach_url varchar(250) NOT NULL,
  attach_type int(4) NOT NULL default '1',
  state tinyint(1) NOT NULL default '1',
  primary key (attach_id)
)TYPE=MyISAM;


-- Table: wiki_categorie
DROP TABLE IF EXISTS wiki_categorie;
CREATE TABLE wiki_categorie (
  cat_id int(12) unsigned auto_increment NOT NULL,
  cat_name varchar(32) NOT NULL,
  cat_level int(6) unsigned NOT NULL default '1',
  cat_parent int(12) unsigned NOT NULL default '0',
  cat_intro varchar(250) NOT NULL default '',
  cat_navi text NOT NULL default '',
  open_ico varchar(128) NOT NULL default '',
  close_ico varchar(128) NOT NULL default '',
  cat_order int(12) unsigned NOT NULL default '0',
  cat_doc_count int(12) unsigned NOT NULL default '0',
  state tinyint(1) NOT NULL default '1',
  primary key (cat_id)
)TYPE=MyISAM;



-- Table: wiki_doc
DROP TABLE IF EXISTS wiki_doc;
CREATE TABLE wiki_doc (
  doc_id int(12) unsigned auto_increment NOT NULL,
  cat_id int(12) unsigned NOT NULL,
  doc_title varchar(250) NOT NULL,
  doc_title_upper varchar(250) NOT NULL,
  doc_summary varchar(250) NOT NULL,
  doc_creator int(12) unsigned NOT NULL,
  doc_created_time datetime NOT NULL default '0000-00-00 00:00',
  doc_content mediumtext NOT NULL,
  doc_latest_edition_time datetime NOT NULL default '0000-00-00 00:00',
  doc_pic_count int(6) unsigned NOT NULL default '0',
  doc_tags varchar(250) NOT NULL,
  doc_seal_time datetime NOT NULL default '2005-07-18',
  doc_click_count int(12) unsigned NOT NULL default '0',
  doc_topic_count int(12) unsigned NOT NULL default '0',
  doc_reply_count int(12) unsigned NOT NULL default '0',
  doc_his_count int(12) unsigned NOT NULL default '1',
  doc_attendee_count int(12) unsigned NOT NULL default '1',
  doc_vote_count int(12) unsigned NOT NULL default '0',
  doc_first_img varchar(250) NOT NULL default '',
  doc_lock tinyint(1) NOT NULL default '0',
  doc_pass tinyint(1) NOT NULL default '1',
  doc_focus tinyint(1) NOT NULL default '0',
  state tinyint(1) NOT NULL default '1',
  primary key (doc_id),
  INDEX (doc_title_upper),
  INDEX (doc_creator),
  INDEX (doc_created_time),
  INDEX (doc_click_count),
  INDEX (doc_latest_edition_time)
)TYPE=MyISAM;

-- Table: wiki_his
DROP TABLE IF EXISTS wiki_his;
CREATE TABLE wiki_his (
  his_id int(12) unsigned auto_increment NOT NULL,
  doc_id int(12) unsigned NOT NULL,
  doc_edition_no int(12) unsigned NOT NULL default '1',
  his_creator int(12) unsigned NOT NULL,
  his_created_time datetime NOT NULL default '0000-00-00 00:00',
  his_content mediumtext NOT NULL,
  his_ip varchar(32) NOT NULL,
  his_tags varchar(250) NOT NULL,
  his_kind tinyint(1) NOT NULL default '0',
  his_reason varchar(250) NOT NULL default '',
  his_coop tinyint(1) NOT NULL default '0',
  his_great tinyint(1) NOT NULL default '0',
  state tinyint(1) NOT NULL default '1',
  primary key (his_id),
  INDEX (doc_id)
)TYPE=MyISAM;


-- Table: wiki_lock
DROP TABLE IF EXISTS wiki_lock;
CREATE TABLE wiki_lock (
  doc_id int(12) unsigned NOT NULL,
  doc_locker int(12) unsigned NOT NULL,
  lock_time datetime NOT NULL default '0000-00-00 00:00',
  state tinyint(1) NOT NULL default '1',
  primary key (doc_id, doc_locker)
)TYPE=MyISAM;

-- Table: wiki_focus
DROP TABLE IF EXISTS wiki_focus;
CREATE TABLE wiki_focus(
  focus_id int(12) unsigned auto_increment NOT NULL,
  doc_id int(12) unsigned NOT NULL,
  doc_title varchar(250) NOT NULL,
  focus_title varchar(250) NOT NULL,
  doc_tags varchar(250) NOT NULL,
  doc_summary varchar(250) NOT NULL,
  doc_imgurl varchar(250) NOT NULL default '',
  doc_created_time datetime NOT NULL default '0000-00-00 00:00:00',
  user_id int(12) unsigned NOT NULL,
  user_nick varchar(250) NOT NULL,
  user_small_ico varchar(250) NOT NULL default '',
  focus_coop text NOT NULL,
  focus_type tinyint(1) NOT NULL default '0',
  focus_order int(8) NOT NULL,
  state tinyint(1) NOT NULL default '1',
  primary key (focus_id)
)TYPE=MyISAM;



-- Table: wiki_reply
DROP TABLE IF EXISTS wiki_reply;
CREATE TABLE wiki_reply (
  reply_id int(12) unsigned auto_increment NOT NULL,
  topic_id int(12) unsigned NOT NULL,
  reply_title varchar(250) NOT NULL,
  reply_content text NOT NULL,
  reply_creator int(12) unsigned NOT NULL,
  reply_ip varchar(32) NOT NULL,
  reply_anony tinyint(1) NOT NULL default '0',
  reply_time datetime NOT NULL default '0000-00-00 00:00',
  state tinyint(1) NOT NULL default '1',
  reply_pass tinyint(1) NOT NULL default '1',
  primary key (reply_id),
  INDEX (topic_id),
  INDEX (reply_time)
)TYPE=MyISAM;


-- Table: wiki_topic
DROP TABLE IF EXISTS wiki_topic;
CREATE TABLE wiki_topic (
  topic_id int(12) unsigned auto_increment NOT NULL,
  doc_id int(12) unsigned NOT NULL,
  topic_title varchar(250) NOT NULL,
  topic_content text NOT NULL,
  topic_creator int(12) unsigned NOT NULL,
  topic_ip varchar(32) NOT NULL,
  topic_anony tinyint(1) NOT NULL default '0',
  topic_created_time datetime NOT NULL default '0000-00-00 00:00',
  topic_view_count int(12) unsigned NOT NULL default '0',
  topic_reply_count int(12) unsigned NOT NULL default '0',
  last_reply_creator int(12) unsigned NOT NULL default '0',
  last_reply_ip varchar(32) NOT NULL,
  last_reply_anony tinyint(1) NOT NULL default '0',
  last_reply_time datetime NOT NULL default '0000-00-00 00:00',
  topic_pass tinyint(1) NOT NULL default '1',
  state tinyint(1) NOT NULL default '1',
  primary key (topic_id),
  INDEX (doc_id),
  INDEX (topic_created_time),
  INDEX (last_reply_time)
)TYPE=MyISAM;


-- Table: wiki_user
DROP TABLE IF EXISTS wiki_user;
CREATE TABLE wiki_user (
  user_id int(12) unsigned auto_increment NOT NULL,
  user_email varchar(250) NOT NULL,
  user_nick varchar(32) NOT NULL,
  user_nick_upper varchar(32) NOT NULL,
  user_password varchar(250) NOT NULL,
  user_city varchar(10) NOT NULL default '',
  user_sex tinyint(1) NOT NULL default '1',
  user_birthday varchar(10) NOT NULL default '',
  user_qq int(12) unsigned NOT NULL default 0,
  user_msn varchar(250) NOT NULL default '',
  user_homepage varchar(250) NOT NULL default '',
  user_intro varchar(250) NOT NULL default '',
  user_true_name varchar(64) NOT NULL default '',
  user_address varchar(250) NOT NULL default '',
  user_tel varchar(64) NOT NULL default '',
  user_reg_time datetime NOT NULL default '0000-00-00 00:00',
  user_click int(12) unsigned NOT NULL default '0',
  user_doc_count int(12) unsigned NOT NULL default '0',
  user_coop_count int(12) unsigned NOT NULL default '0',
  user_topic_count int(12) unsigned NOT NULL default '0',
  user_reply_count int(12) unsigned NOT NULL default '0',
  user_bonus int(12) NOT NULL default '0',
  user_small_ico varchar(250) NOT NULL default '',
  user_big_ico varchar(250) NOT NULL default '',
  last_login_ip varchar(32) NOT NULL default '',
  last_login_time datetime NOT NULL default '0000-00-00 00:00',
  user_space_name varchar(250) NOT NULL default '',
  user_space_intro varchar(250) NOT NULL default '',
  user_time_offset varchar(20) NOT NULL default '8',
  user_style varchar(255) NOT NULL default 'default',
  user_lang varchar(255) NOT NULL default 'zh',
  usergroup_id int(12) unsigned NOT NULL default '2',
  state tinyint(1) NOT NULL default '1',
  primary key (user_id),
  INDEX (user_email),
  INDEX(user_nick_upper),
  INDEX(user_reg_time)
)TYPE=MyISAM;


-- Table: wiki_rolerel
DROP TABLE IF EXISTS wiki_usergroup;
CREATE TABLE wiki_usergroup (
  usergroup_id int(12) unsigned	auto_increment	NOT NULL,
  allow_post   tinyint(1) NOT NULL default '1',
  allow_reply  tinyint(1) NOT NULL default '1',
  allow_create tinyint(1) NOT NULL default '1',
  allow_edit   tinyint(1) NOT NULL default '1',
  allow_board   tinyint(1) NOT NULL default '1',
  base_config  tinyint(1) NOT NULL default '0',
  upload_logo  tinyint(1) NOT NULL default '0',
  bonus_config  tinyint(1) NOT NULL default '0',
  del_user      tinyint(1) NOT NULL default '0',
  add_cat tinyint(1) NOT NULL default '0',
  edit_cat tinyint(1) NOT NULL default '0',
  del_cat tinyint(1) NOT NULL default '0',
  del_doc tinyint(1) NOT NULL default '0',
  verify_doc tinyint(1) NOT NULL default '0',
  lock_doc tinyint(1) NOT NULL default '0',
  unlock_doc tinyint(1) NOT NULL default '0',
  move_doc tinyint(1) NOT NULL default '0',
  rename_doc tinyint(1) NOT NULL default '0',
  del_topic  tinyint(1) NOT NULL default '0',
  verify_topic tinyint(1) NOT NULL default '0',
  plugin_manage tinyint(1) NOT NULL default '0',
  plugin_position  tinyint(1) NOT NULL default '0',
  task_manage tinyint(1) NOT NULL default '0',
  ip_banned tinyint(1) NOT NULL default '0',
  del_his tinyint(1) NOT NULL default '0',
  great_his tinyint(1) NOT NULL default '0',
  copy_his tinyint(1) NOT NULL default '0',
  momo_manage tinyint(1) NOT NULL default '0',

  allow_manage tinyint(1) NOT NULL default '0',
  discuz_config tinyint(1) NOT NULL default '0',
  seo_config tinyint(1) NOT NULL default '0',
  cache_config tinyint(1) NOT NULL default '0',

  add_link tinyint(1) NOT NULL default '0',
  del_link tinyint(1) NOT NULL default '0',
  edit_link tinyint(1) NOT NULL default '0',
  backup_database tinyint(1) NOT NULL default '0',
  optimize_database tinyint(1) NOT NULL default '0',
  recommended_focus tinyint(1) NOT NULL default '0',
  state tinyint(1) NOT NULL default '1',
  primary key (usergroup_id)
)TYPE=MyISAM;


-- Table: wiki_hottag
DROP TABLE IF EXISTS wiki_hottag;
CREATE TABLE wiki_hottag (
  hottag_id int(12) unsigned auto_increment NOT NULL,
  cat_id int(12) unsigned  NOT NULL,
  hottag_name varchar(32) NOT NULL,
  hottag_count int(12) unsigned NOT NULL default '0',
  state tinyint(1) NOT NULL default '1',
  primary key (hottag_id),
  INDEX (hottag_name),
  INDEX (hottag_count)
)TYPE=MyISAM;


-- Table: wiki_plugin
DROP TABLE IF EXISTS wiki_plugin;
CREATE TABLE wiki_plugin (
	plug_id int(12) unsigned auto_increment NOT NULL,
	plug_name varchar(125) NOT NULL ,
	plug_descripe varchar(125) ,
	plug_path varchar(125) NOT NULL ,
	plug_code text,
	plug_status TINYINT(1) DEFAULT '1' NOT NULL ,
	plug_type varchar(125) NOT NULL default 'content',
	plug_order INT NOT NULL default '0',
	plug_dateline INT NOT NULL ,
	state tinyint(1) NOT NULL default '1',
    PRIMARY KEY (plug_id)
) TYPE = MYISAM ;


-- Table: wiki_task
DROP TABLE IF EXISTS wiki_task;
CREATE TABLE wiki_task (
	task_id int(12) unsigned auto_increment NOT NULL,
	task_name varchar(125) NOT NULL,
	task_url  varchar(125) NOT NULL,
	task_lastrun  datetime NOT NULL default '0000-00-00 00:00',
	task_nextrun  datetime NOT NULL default '0000-00-00 00:00',
	task_weekday  tinyint(1) NOT NULL,
	task_day  tinyint(1) NOT NULL,
	task_hour  tinyint(2)  NOT NULL ,
	task_minute tinyint(2)  NOT NULL,
	task_status  tinyint(1) NOT NULL  DEFAULT '1' ,
	state  tinyint(1) NOT NULL default '1',
    PRIMARY KEY (task_id)
) TYPE = MYISAM ;


-- Table: wiki_banned
DROP TABLE IF EXISTS wiki_banned;
CREATE TABLE wiki_banned (
  banned_id smallint(6) unsigned auto_increment NOT NULL,
  banned_ip1 smallint(3) NOT NULL default '0',
  banned_ip2 smallint(3) NOT NULL default '0',
  banned_ip3 smallint(3) NOT NULL default '0',
  banned_ip4 smallint(3) NOT NULL default '0',
  banned_user varchar(32) NOT NULL,
  banned_time date NOT NULL default '0000-00-00',
  banned_expiration date NOT NULL default '0000-00-00',
  state tinyint(1) unsigned NOT NULL default '1',
  PRIMARY KEY  (banned_id)
) TYPE =MyISAM;


-- Table: wiki_momo
DROP TABLE IF EXISTS wiki_momo;
CREATE TABLE wiki_momo (
  momo_id int(12) unsigned auto_increment NOT NULL,
  momo_name varchar(32) NOT NULL,
  momo_words mediumtext NOT NULL,
  momo_keywords_count int(8) NOT NULL,
  momo_encoding varchar(8) NOT NULL default 'utf8',
  momo_style int(8) NOT NULL default '1',
  momo_effect varchar(16) NOT NULL default '1',
  momo_linkcolor varchar(8) NOT NULL default '#0000FF',
  momo_maxcount int(8) NOT NULL default '5',
  momo_minspace int(8) NOT NULL default '10',
  momo_area varchar(32) default NULL,
  state tinyint(1) NOT NULL default '1',
  PRIMARY KEY  (momo_id)
) TYPE=MyISAM;


-- Table: wiki_setting
DROP TABLE IF EXISTS wiki_setting;
CREATE TABLE wiki_setting (
  variable varchar(32) NOT NULL,
  value text,
  PRIMARY KEY  (variable)
) TYPE=MyISAM;

-- Table: wiki_friendlink
DROP TABLE IF EXISTS wiki_friendlink;
CREATE TABLE wiki_friendlink (
  link_id int(12) NOT NULL auto_increment,
  link_name varchar(250) NOT NULL,
  link_url varchar(250) NOT NULL,
  link_logo varchar(250) NULL,
  link_description varchar(250)  NULL,
  link_display tinyint(1) NOT NULL,
  link_order tinyint(2) NOT NULL,
  state tinyint(1) NOT NULL,
  PRIMARY KEY  (link_id)
) TYPE=MyISAM ;


DROP TABLE IF EXISTS wiki_board;
CREATE TABLE wiki_board (
  board_id int(12) unsigned auto_increment NOT NULL,
  user_id int(12) unsigned NOT NULL,
  board_content text NOT NULL,
  board_creator int(12) unsigned NOT NULL,
  board_ip varchar(32) NOT NULL,
  board_anony tinyint(1) NOT NULL default '0',
  board_time datetime NOT NULL default '0000-00-00 00:00',
  state tinyint(1) NOT NULL default '1',
  primary key (board_id),
  INDEX (user_id)
)TYPE=MyISAM;

DROP TABLE IF EXISTS wiki_style;
CREATE TABLE wiki_style (
  style_id int(12) unsigned auto_increment NOT NULL,
  style_name varchar(255)  NOT NULL,
  style_path varchar(255)  NOT NULL,
  style_copyright varchar(255)  NOT NULL,
  state tinyint(1) NOT NULL default '1',
  primary key (style_id)
)TYPE=MyISAM;

DROP TABLE IF EXISTS wiki_lang;
CREATE TABLE wiki_lang (
  lang_id int(12) unsigned auto_increment NOT NULL,
  lang_name varchar(255)  NOT NULL,
  lang_filename varchar(255)  NOT NULL,
  state tinyint(1) NOT NULL default '1',
  primary key (lang_id)
)TYPE=MyISAM;