<?php
/**
 * This is NOT a freeware, use is subject to license terms
 * @copyright Hodong Inc
 * @version 2.0
 * @final 2007-3-19
 * @todo document
 * @package MediaWiki
 */
if(ini_get('safe_mode')==1)
{
	echo $lang['mdwikiUnableSetSafeMode'];
	exit();
}
set_time_limit (0);

define( 'MW_PARSER_VERSION', '1.6.1' );
define( 'RLH_FOR_UPDATE', 1 );
# Allowed values for $mOutputType
define( 'OT_HTML', 1 );
define( 'OT_WIKI', 2 );
define( 'OT_MSG' , 3 );
define( 'OT_PREPROCESS', 4 );

# Flags for setFunctionHook
define( 'SFH_NO_HASH', 1 );

# string parameter for extractTags which will cause it
# to strip HTML comments in addition to regular
# <XML>-style tags. This should not be anything we
# may want to use in wikisyntax
define( 'STRIP_COMMENTS', 'HTMLCommentStrip' );

# Constants needed for external link processing
define( 'HTTP_PROTOCOLS', 'http:\/\/|https:\/\/' );
# Everything except bracket, space, or control characters
define( 'EXT_LINK_URL_CLASS', '[^][<>"\\x00-\\x20\\x7F]' );
# Including space, but excluding newlines
define( 'EXT_LINK_TEXT_CLASS', '[^\]\\x0a\\x0d]' );
define( 'EXT_IMAGE_FNAME_CLASS', '[A-Za-z0-9_.,~%\\-+&;#*?!=()@\\x80-\\xFF]' );
define( 'EXT_IMAGE_EXTENSIONS', 'gif|png|jpg|jpeg' );
// State constants for the definition list colon extraction
define( 'MW_COLON_STATE_TEXT', 0 );
define( 'MW_COLON_STATE_TAG', 1 );
define( 'MW_COLON_STATE_TAGSTART', 2 );
define( 'MW_COLON_STATE_CLOSETAG', 3 );
define( 'MW_COLON_STATE_TAGSLASH', 4 );
define( 'MW_COLON_STATE_COMMENT', 5 );
define( 'MW_COLON_STATE_COMMENTDASH', 6 );
define( 'MW_COLON_STATE_COMMENTDASHDASH', 7 );

class ParserOutput
{
	var $mText,             # The output text
		$mLanguageLinks,    # List of the full text of language links, in the order they appear
		$mCategories,       # Map of category names to sort keys
		$mContainsOldMagic, # Boolean variable indicating if the input contained variables like {{CURRENTDAY}}
		$mCacheTime,        # Time when this object was generated, or -1 for uncacheable. Used in ParserCache.
		$mVersion,          # Compatibility check
		$mTitleText,        # title text of the chosen language variant
		$mLinks,            # 2-D map of NS/DBK to ID for the links in the document. ID=zero for broken.
		$mTemplates,        # 2-D map of NS/DBK to ID for the template references. ID=zero for broken.
		$mImages,           # DB keys of the images used, in the array key only
		$mExternalLinks,    # External link URLs, in the key only
		$mHTMLtitle,		# Display HTML title
		$mSubtitle,			# Additional subtitle
		$mNewSection,		# Show a new section link?
		$mNoGallery;		# No gallery on category page? (__NOGALLERY__)

	function ParserOutput( $text = '', $languageLinks = array(), $categoryLinks = array(),
		$containsOldMagic = false, $titletext = '' )
	{
		$this->mText = $text;
		$this->mLanguageLinks = $languageLinks;
		$this->mCategories = $categoryLinks;
		$this->mContainsOldMagic = $containsOldMagic;
		$this->mCacheTime = '';
		$this->mVersion = MW_PARSER_VERSION;
		$this->mTitleText = $titletext;
		$this->mLinks = array();
		$this->mTemplates = array();
		$this->mImages = array();
		$this->mExternalLinks = array();
		$this->mHTMLtitle = "" ;
		$this->mSubtitle = "" ;
		$this->mNewSection = false;
		$this->mNoGallery = false;
	}
}
require_once  HDWIKI_ROOT."./include/common.func.php";
require_once  HDWIKI_ROOT."./include/admin.func.php";
require_once  HDWIKI_ROOT."./include/plugin.func.php";


function Replacemdwiki($arr,$url)
{
	$arr=preg_replace('/<DIV(\s*)class=\"editsection\"(\s*)style=\"float:right;margin-left:5px;\">(.*)<\/DIV>/i'," ", $arr);
	$arr=preg_replace('/<H2>/i','<DIV class=hdwiki_tmml>', $arr);
	$arr=preg_replace('/<\/H2>/i','</DIV>', $arr);
	$arr=preg_replace('/<A(\s*)name=(.*)>(.*)<\/A>/i',' ',$arr);
	$arr=preg_replace('/<!--(.*)-->/i',' ',$arr);
	$arr=preg_replace('/action\=edit/i','action=view',$arr);
	$arr=preg_replace("/href\=\"index\.php\//i",'class=innerlink href="doc.php?action=view&title=',$arr);
	$arr=preg_replace("/href\=\"index\.php/i",'class=innerlink href="doc.php',$arr);
	$arr=preg_replace("/href\=\"\#[^\s]*\"/i",'href="#"',$arr);
	$arr=preg_replace("/href\=\"(([^h])|(h[^t])|(ht[^t])|(htt[^p])|(http[^\:])|(http\:[^\/])|(http\:\/[^\/]))([^\s]*)index\.php/i",'class=innerlink href="doc.php',$arr);
	return addslashes($arr);
}



function mduserInsert( $arr_regInfo ){
	global $g_table_prefix,$db;
		$user_email = strtolower($arr_regInfo['email_addr']);
		$user_nick = $arr_regInfo['nick_name'];
		$user_nick_upper = hstrtoupper($arr_regInfo['nick_name']);
		$user_password =$arr_regInfo['password'];
		$user_sex = 1;
		$user_birthday = createServerTime('',"Y-m-d");
		$user_reg_time = createServerTime();
		$last_login_ip = $_SERVER['REMOTE_ADDR'];
		$last_login_time = createServerTime();
		$state = 1;


		$sql="insert into {$g_table_prefix}user (user_email,user_nick,user_nick_upper,user_password,user_sex,user_birthday,user_reg_time,last_login_ip,last_login_time,state) values ('$user_email','$user_nick','$user_nick_upper','$user_password','$user_sex','$user_birthday','$user_reg_time','$last_login_ip','$last_login_time','$state')";
		$db->query($sql);

}

if(isAdminLogin()!=true)
{exit ('<h1>Access Denied</h1>');}

$tpl->cache_lifetime =0;

@$user=reloadUser();
if($user['usergroup_id']!=4)
{
	adminInfotip($tpl, $lang['commonLackOfPower'], '', 'error');
	exit();
}

$insertarr=$_REQUEST;
if(isset($insertarr['insertsubmit']))
{
	if($insertarr['mdwikidbname']==""||$insertarr['mdwikidbuser']==""||$insertarr['mdwikidbpwd']=="")
	{
		adminInfotip($tpl,$lang['mdwikiNotInputComplete'],'','error');
		exit();
	}


 	$mdwikilink = mysql_connect($insertarr['mdwikidbhost'], $insertarr['mdwikidbuser'], $insertarr['mdwikidbpwd']) or die($lang['mdwikiCanNotConnectDb'].mysql_error());
 	if(!@mysql_select_db($insertarr['mdwikidbname']))
	{
		adminInfotip($tpl, $lang['mdwikiDbNotExist'], '', 'error');
    	exit();
  	}
  	mysql_select_db($insertarr['mdwikidbname']) or die($lang['mdwikiPleaseInputDbName']);
  	$tablename=$insertarr['mdwikidbpre'];
	$tablename1=$tablename."page";
	$tablename2=$tablename."text";
	if(mysql_num_rows(mysql_query("SHOW TABLES LIKE '".$tablename1."'"))!=1||mysql_num_rows(mysql_query("SHOW TABLES LIKE '".$tablename2."'"))!=1)
	{
		adminInfotip($tpl, $lang['mdwikiDbTableNotExist'], '', 'error');
		exit();
	}
	$query="SELECT count(*) total
			FROM ".$tablename1." a, ".$tablename2." b
			WHERE a.page_id >1281
			AND a.page_latest = b.old_id";
	$result = mysql_query($query) or die('Query failed: ' . mysql_error().$lang['mdwikiGoBack']);
	$sumno = mysql_fetch_array($result, MYSQL_ASSOC);
	$casetotal=$sumno['total'];
	if($casetotal==0)
	{
		adminInfotip($tpl, $lang['mdwikiCanNotImport'], '', 'error');
		exit();
	}

	$tablename=$insertarr['mdwikidbpre'];
	$tablename=$tablename."user";
	$query = "SELECT count(*) total FROM ".$tablename." where 1 ";
	$result = mysql_query($query) or die('Query failed: ' . mysql_error().$lang['mdwikiGoBack']);
	$sumno = mysql_fetch_array($result, MYSQL_ASSOC);
	$usertotal=$sumno['total'];

	mysql_free_result($result);
	mysql_close($mdwikilink);

	$i=0;
	$doc_number=0;
	while($i < $casetotal ){
	   $mdwikilink = mysql_connect($insertarr['mdwikidbhost'], $insertarr['mdwikidbuser'], $insertarr['mdwikidbpwd']) or die('Could not connect: ' . mysql_error());
		mysql_select_db($insertarr['mdwikidbname']) or die('Could not select database,please check your inputfiles!'.mysql_error().$lang['mdwikiGoBack']);

		$tablename=$insertarr['mdwikidbpre'];
		$tablename1=$tablename."page";
		$tablename2=$tablename."text";
		$query="SELECT a.page_id, a.page_title, b.old_text, b.old_flags
				FROM ".$tablename1." a, ".$tablename2." b
				WHERE a.page_id >1281
				AND a.page_latest = b.old_id
				limit ".$i.",100";
		mysql_query('SET NAMES latin1');
		$result = mysql_query($query) or die('Query failed: ' . mysql_error().$lang['mdwikiGoBack']);


		unset($linelist);
		while ($line = mysql_fetch_array($result, MYSQL_ASSOC)){
			$cachequery="select value from ".$insertarr['mdwikidbpre']."objectcache where keyname like '%".$line['page_id']."%'";
			$cacheresult = mysql_query($cachequery) or die('Query failed: ' . mysql_error().$lang['mdwikiGoBack']);
			$cacheline = mysql_fetch_array($cacheresult, MYSQL_ASSOC);
			if($cacheline['value']==""){
				continue;
			}
			$doc_content=@gzinflate($cacheline['value']);
 			$tem=unserialize($doc_content);
			$line['old_text']=$tem->mText;
			$line['old_text']=Replacemdwiki($line['old_text'],$insertarr['domain']);
  			$linelist[]=$line;
		}

		mysql_free_result($result);
		mysql_close($mdwikilink);

		$insert_status=0;
		$db =new Db($g_db_host,$g_db_user,$g_db_pwd,$g_db_name,$g_db_charset);
		foreach($linelist as $insertline)
		{
			@$user=reloadUser();
			$cat = 1;
			$title = $insertline['page_title'];
			$content =$insertline['old_text'];
			$tag=$insertline['page_title'];
			$query=$db->query( "select count (*) from ".$g_table_prefix."doc where doc_title_upper='$title'" );
			$rownum=$db->result($query,0);
			if($rownum>0) {
				continue;
			}
			$insert_status=1;
			$summary=strip_tags($content);
			$summary=subString($summary,0,100);
			$createtime= createServerTime();
			$doc_first_img=setFirstImg($content);
			$db->query( "insert into {$g_table_prefix}doc(cat_id,doc_title,doc_title_upper,doc_summary,doc_creator,doc_created_time,doc_content,doc_latest_edition_time,doc_tags,doc_first_img)
							 values($cat,"."'".$title."','".hstrtoupper($title)."','".$summary."',".$user['user_id'].",'".$createtime."','".$content."','".$createtime."','".$tag."','".$doc_first_img."')");
			$doc_id = $db->insert_id();
			$db->query( "insert into {$g_table_prefix}his(doc_id,his_creator,his_created_time,his_content,his_ip,his_tags,his_kind,his_coop)
							 values($doc_id,".$user['user_id'].",'".$createtime."','".$content."','".$_SERVER['REMOTE_ADDR']."','".$tag."',1,0)");
			$db->query( "update {$g_table_prefix}user set user_doc_count=user_doc_count+1,user_bonus=user_bonus+".$CREATEDOCBONUS." where user_id=".$user['user_id'] );
			$db->query( "update {$g_table_prefix}categorie set cat_doc_count=cat_doc_count+1  where cat_id=".$cat );
			$doc_number++;
		}
		$i = $i + 100;
	}

	$j=0;
	$user_count=0;
	$inipasswd=$insertarr['mdwikiupwd'];
	$inipasswd=md5($inipasswd);
	while($j < $usertotal)
	{
		$mdwikilink = mysql_connect($insertarr['mdwikidbhost'], $insertarr['mdwikidbuser'], $insertarr['mdwikidbpwd']) or die('Could not connect: ' . mysql_error());
  		mysql_select_db($insertarr['mdwikidbname']) or die('Could not select database,please check your inputfiles!' . mysql_error().$lang['mdwikiGoBack']);
		mysql_query('SET NAMES utf8');
  		$tablename=$insertarr['mdwikidbpre'];
		$tablename=$tablename."user";
		$query = "SELECT * FROM ".$tablename." where 1 limit ".$j.",100";
		$result = mysql_query($query) or die('Query failed: ' . mysql_error().$lang['mdwikiGoBack']);
		unset($linelist);
		while ($line = mysql_fetch_array($result, MYSQL_ASSOC))
		{
			if(!empty($line['user_newpassword']))
			{$line['user_password']=$line['user_newpassword'];}
  			$linelist[]=$line;
		}
		mysql_free_result($result);
		mysql_close($mdwikilink);


	    $db =new Db($g_db_host,$g_db_user,$g_db_pwd,$g_db_name,$g_db_charset);
		foreach($linelist as $mediauser)
		{
			$arr_regInfo['email_addr'] = $mediauser['user_email'];
			$arr_regInfo['password'] = $inipasswd;
			$arr_regInfo['re_password'] = $mediauser['user_possword'];
			$arr_regInfo['nick_name'] = $mediauser['user_name'];

			$query=$db->query( "select * from ".$g_table_prefix."user where user_email='$arr_regInfo[email_addr]'" );
			$rownum=$db->result($query,0);
			if($rownum>0)continue;

			mduserInsert( $arr_regInfo );
			$user_count++;
		}
		$j=$j + 100;
	}
	adminInfotip($tpl,$doc_number.$lang['mdwikiDocImportComplete'].$user_count.$lang['mdwikiUserImportComplete'],'','error');
}
else
{
	$tpl->assign('mdwikidbhost',$g_db_host);
	$tpl->assign('mdwikidbname',$g_db_name);
	$tpl->assign('mdwikidbuser',$g_db_user);
	$tpl->assign('mdwikidbpwd',$g_db_pwd);
	$tpl->assign('mdwikidbpre','');
	$tpl->display('_mdwiki');
}

?>